#Code used to determine register values in setting up UART communication
#on an LPC1769 microcontroller.
#Inputs: Peripheral Clock and Desired Baud Rate
#Outputs: Values for MULVAL, DIVADDVAL, DLM, DLL registers
# Created by Michael Kilzer (mjk277) for Cornell University MEng Project

import sys
PCLK = int(sys.argv[1])
BR = int(sys.argv[2])

print('PCLK: %d' %(PCLK))
print('BR: %d' %(BR))

DLM = 0
DLL = 0
DIVADDVAL = 0
MULVAL = 0
i = 0	

key = 0
prevA = 0

DLest = PCLK / (16.0*BR)

#print('DLest: %f' %(DLest))


table = {}
	
table[1.000] = (0,1);
table[1.067] = (1,15);
table[1.071] = (1,14);
table[1.077] = (1,13);
table[1.083] = (1,12);
table[1.091] = (1,11);
table[1.100] = (1,10);
table[1.111] = (1,9);
table[1.125] = (1,8);
table[1.133] = (2,15);
table[1.143] = (1,7);
table[1.154] = (2,13);
table[1.167] = (1,6);
table[1.182] = (2,11);
table[1.200] = (1,5);
table[1.214] = (3,14);
table[1.222] = (2,9);
table[1.231] = (3,13);

table[1.250] = (1,4);
table[1.267] = (4,15);
table[1.273] = (3,11);
table[1.286] = (2,7);
table[1.300] = (3,10);
table[1.308] = (4,13);
table[1.333] = (1,3);
table[1.357] = (5,14);
table[1.364] = (4,11);
table[1.375] = (3,8);
table[1.385] = (5,13);
table[1.400] = (2,5);
table[1.417] = (5,12);
table[1.429] = (3,7);
table[1.444] = (4,9)
table[1.455] = (5,11)
table[1.462] = (6,13)
table[1.467] = (7,15)

table[1.500] = (1,2)
table[1.533] = (8,15)
table[1.538] = (7,13)
table[1.545] = (6,11)
table[1.556] = (5,9)
table[1.571] = (4,7)
table[1.583] = (7,12)
table[1.600] = (3,5)
table[1.615] = (8,13)
table[1.625] = (5,8)
table[1.636] = (7,11)
table[1.643] = (9,14)
table[1.667] = (2,3)
table[1.692] = (9,13)
table[1.700] = (7,10)
table[1.714] = (5,7)
table[1.727] = (8,11)
table[1.733] = (11,15)

table[1.750] = (3,4)
table[1.769] = (10,13)
table[1.778] = (7,9)
table[1.786] = (11,14)
table[1.800] = (4,5)
table[1.818] = (9,11)
table[1.833] = (5,6)
table[1.846] = (11,13)
table[1.857] = (6,7)
table[1.867] = (13,15)
table[1.875] = (7,8)
table[1.889] = (8,9)
table[1.900] = (9,10)
table[1.909] = (10,11)
table[1.917] = (11,12)
table[1.923] = (12,13)
table[1.929] = (13,14)
table[1.933] = (14,15)
	
FRestIterate = [1.5, 1.2, 1.3, 1.4, 1.1, 1.6, 1.7, 1.8, 1.9]
FRest = 0
if(DLest - int(DLest) == 0):
   DIVADDVAL = 0
   MULVAL = 1
else:
   while(not (FRest > 1.1 and FRest < 1.9)):
      FRest = FRestIterate[i]
      DLest = int(PCLK / (16.0*BR*FRest))
      
#      print('FRest1: %f Iteration: %d' %(FRest,i))
#      print('DLest: %f Iteration: %d' %(DLest,i))      
      FRest = PCLK/(16.0*BR*DLest)
      i = i + 1
      
#      print('FRest2: %f Iteration: %d' %(FRest,i))


#   print('FRest: %f' %(FRest))

   for a in sorted(table):
#      print('a_iterate: %f' %(a))
      if (a > FRest):
         if(abs((prevA - FRest)) < abs(a - FRest)):
            key = prevA
            
 #           print('prevA: %f' %(prevA))
            break
         else: 
            key = a

 #           print('a: %f' %(a))
            break
      prevA = a

   DIVADDVAL = table[key][0]
   MULVAL = table[key][1]
   
   #print('DLest: %f' %(DLest))

DLM = int(DLest) & 0xFF00
DLL = int(DLest) & 0x00FF 
		
print('MULVAL %d, DIVADDVAL %d, DLM %d, DLL %d' %(MULVAL, DIVADDVAL, DLM, DLL))
